%define		intname php
%global contentdir  /var/www
%global apiver      20090626
%global zendver     20090626

Distribution:	CCux
Packager:	Karsten Brockmann <arcam@ccux-linux.de>

Name:		php5
Version:	5.3.2
Release:	3
BuildArch:	i686
Summary:	PHP: Hypertext Preprocessor
URL:		http://www.php.net/
Group:		Development/PHP
License:	PHP
Source0:	%{intname}-%{version}.tar.bz2
Source1: 	php.conf
Source2: 	php.ini
Patch0:		suhosin-patch-%{version}-0.9.9.1.patch
Patch1: 	php-5.3.0-install.patch
Patch2: 	php-5.2.0-includedir.patch
Provides:	php mod-php
Conflicts:	php4
Requires: 	php5-common = %{version}-%{release}
Requires:	httpd
#Automatically resolved build dependencies
BuildRequires: bzip2-devel
BuildRequires: curl-devel
BuildRequires: cyrus-sasl-devel
BuildRequires: db-devel
BuildRequires: expat-devel
BuildRequires: fontconfig-devel
BuildRequires: freetype-devel
BuildRequires: gdbm-devel
BuildRequires: gettext-devel
BuildRequires: glibc-devel
BuildRequires: libX11-devel
BuildRequires: libXpm-devel
BuildRequires: libgd-devel
BuildRequires: libidn-devel
BuildRequires: libjpeg-devel
BuildRequires: libpng-devel
BuildRequires: libxml2-devel
BuildRequires: mysql-devel
BuildRequires: net-snmp-devel
BuildRequires: openldap-devel libssh2-devel
BuildRequires: openssl-devel readline-devel libxslt-devel libgcrypt-devel libgpg-error-devel libtasn1-devel
BuildRequires: unixODBC-devel t1lib-devel gmp-devel libicu-devel libmcrypto-devel recode-devel tidy-devel
BuildRequires: zlib-devel mysql-devel httpd-devel pcre-devel >= 8.00 pcre >= 8.00 sqlite-devel enchant-devel

%description
PHP is an HTML-embedded scripting language. Much of its syntax is
borrowed from C, Java and Perl with a couple of unique PHP-specific
features thrown in. The goal of the language is to allow web
developers to write dynamically generated pages quickly.

%package devel
Summary:        PHP development headers.
Group:          Development/PHP
Requires:       %{name} = %{version}-%{release}
Requires:	mysql-devel libgd-devel libjpeg-devel cyrus-sasl-devel
Requires:	libpng-devel db-devel zlib-devel bzip2-devel openssl-devel
Requires:	openldap-devel pcre-devel gettext-devel freetype-devel
Requires:	expat-devel libxml2-devel libxslt-devel curl-devel
Requires:	gdbm-devel net-snmp-devel unixODBC-devel httpd-devel
Requires:	krb5-devel curl-devel t1lib-devel libmcrypto-devel
Provides:	php-devel
Obsoletes:	php-devel
Conflicts:	php4-devel

%description devel
Header and include files for developing applications with PHP.

%package cli
Group: 		Development/Languages
Summary: 	Command-line interface for PHP
Requires: 	php5-common = %{version}-%{release}
Provides: 	php5-cgi = %{version}-%{release}

%description cli
The php-cli package contains the command-line interface 
executing PHP scripts, /usr/bin/php, and the CGI interface.

%package common
Group: 		Development/Languages
Summary: 	Common files for PHP
Provides: 	php-api = %{apiver}, php-zend-abi = %{zendver}
Provides: 	php(api) = %{apiver}, php(zend-abi) = %{zendver}
# Provides for all builtin modules:
Provides: 	php-bz2, php-calendar, php-ctype, php-curl, php-date, php-exif
Provides: 	php-ftp, php-gettext, php-gmp, php-hash, php-iconv, php-libxml
Provides: 	php-reflection, php-session, php-shmop, php-simplexml, php-sockets
Provides: 	php-spl, php-tokenizer, php-openssl, php-pcre
Provides: 	php-zlib, php-json, php-zip, php-fileinfo

%description common
The php-common package contains files used by both the php
package and the php-cli package.

%prep
%setup -qn %{intname}-%{version}
%patch0 -p1
%patch1 -p1
%patch2 -p1

mkdir build-cgi build-apache build-embedded

%build
# Install extension modules in %{_libdir}/php/modules.
EXTENSION_DIR=%{_libdir}/php/modules; export EXTENSION_DIR

# Set PEAR_INSTALLDIR to ensure that the hard-coded include_path
# includes the PEAR directory even though pear is packaged
# separately.
PEAR_INSTALLDIR=%{_datadir}/pear; export PEAR_INSTALLDIR

# Shell function to configure and build a PHP tree.
build() {
# bison-1.875-2 seems to produce a broken parser; workaround.
mkdir Zend && cp ../Zend/zend_{language,ini}_{parser,scanner}.[ch] Zend
ln -sf ../configure
PCRE_INCDIR="/usr/include" %configure \
	--cache-file=../config.cache \
        --with-libdir=%{_lib} \
	--with-config-file-path=%{_sysconfdir} \
	--with-config-file-scan-dir=%{_sysconfdir}/php.d \
	--disable-debug \
	--with-pic \
	--disable-rpath \
	--without-pear \
	--with-bz2 \
	--with-exec-dir=%{_bindir} \
	--with-freetype-dir=%{_prefix} \
	--with-png-dir=%{_prefix} \
	--with-xpm-dir=%{_prefix} \
	--enable-gd-native-ttf \
	--with-t1lib=%{_prefix} \
	--without-gdbm \
	--with-gettext \
	--with-gmp \
	--with-iconv \
	--with-jpeg-dir=%{_prefix} \
	--with-openssl \
	--with-zlib \
	--with-layout=GNU \
	--enable-exif \
	--enable-ftp \
	--enable-magic-quotes \
	--enable-sockets \
	--enable-sysvsem --enable-sysvshm --enable-sysvmsg \
	--with-kerberos \
	--enable-ucd-snmp-hack \
	--enable-shmop \
	--enable-calendar \
        --without-mime-magic \
        --without-sqlite \
        --with-libxml-dir=%{_prefix} \
	--enable-xml \
        --with-system-tzdata \
	$* 
if test $? != 0; then 
  tail -500 config.log
  : configure failed
  exit 1
fi

make %{?_smp_mflags}
}

# Build /usr/bin/php-cgi with the CGI SAPI, and all the shared extensions
pushd build-cgi
build --enable-force-cgi-redirect \
      --enable-pcntl \
      --enable-mbstring=shared \
      --enable-mbregex \
      --with-gd=shared \
      --enable-bcmath=shared \
      --enable-dba=shared --with-db4=%{_prefix} \
      --with-xmlrpc=shared \
      --with-ldap=shared --with-ldap-sasl \
      --with-mysql=shared,%{_prefix} \
      --with-mysqli=shared,%{_bindir}/mysql_config \
      --enable-dom=shared \
      --enable-wddx=shared \
      --with-snmp=shared,%{_prefix} \
      --enable-soap=shared \
      --with-xsl=shared,%{_prefix} \
      --enable-xmlreader=shared --enable-xmlwriter=shared \
      --with-curl=shared,%{_prefix} \
      --enable-fastcgi \
      --enable-pdo=shared \
      --with-pdo-odbc=shared,unixODBC,%{_prefix} \
      --with-pdo-mysql=shared,%{_prefix} \
      --with-pdo-sqlite=shared,%{_prefix} \
      --with-sqlite3=shared,%{_prefix} \
      --enable-json=shared \
      --enable-zip=shared \
      --without-readline \
      --enable-phar=shared \
      --with-tidy=shared,%{_prefix} \
      --enable-sysvmsg=shared --enable-sysvshm=shared --enable-sysvsem=shared \
      --enable-posix=shared \
      --with-unixODBC=shared,%{_prefix} \
      --enable-fileinfo=shared \
      --enable-intl=shared \
      --with-icu-dir=%{_prefix} \
      --with-enchant=shared,%{_prefix} \
      --with-recode=shared,%{_prefix}
popd

without_shared="--without-mysql --without-gd \
      --disable-dom --disable-dba --without-unixODBC \
      --disable-pdo --disable-xmlreader --disable-xmlwriter \
      --without-sqlite3 --disable-phar --disable-fileinfo \
      --disable-json --without-pspell --disable-wddx \
      --without-curl --disable-posix \
      --disable-sysvmsg --disable-sysvshm --disable-sysvsem"

# Build Apache module, and the CLI SAPI, /usr/bin/php
pushd build-apache
build --with-apxs2=%{_sbindir}/apxs ${without_shared}
popd

# Build for inclusion as embedded script language into applications,
# /usr/lib/libphp5.so
#pushd build-embedded
#build --enable-embed ${without_shared}
#popd

#%check
#cd build-apache
# Run tests, using the CLI SAPI
#export NO_INTERACTION=1 REPORT_EXIT_STATUS=1 MALLOC_CHECK_=2
#unset TZ LANG LC_ALL
#if ! make test; then
#  set +x
#  for f in `find .. -name \*.diff -type f -print`; do
#    echo "TEST FAILURE: $f --"
#    cat "$f"
#    echo "-- $f result ends."
#  done
#  set -x
#  #exit 1
#fi
#unset NO_INTERACTION REPORT_EXIT_STATUS MALLOC_CHECK_
#

%install
[ "$RPM_BUILD_ROOT" != "/" ] && rm -rf $RPM_BUILD_ROOT

# Install the version for embedded script language in applications + php_embed.h
#make -C build-embedded install-sapi install-headers INSTALL_ROOT=$RPM_BUILD_ROOT

# Install everything from the CGI SAPI build
make -C build-cgi install INSTALL_ROOT=$RPM_BUILD_ROOT 

# Install the default configuration file and icons
install -m 755 -d $RPM_BUILD_ROOT%{_sysconfdir}/
install -m 644 %{SOURCE2} $RPM_BUILD_ROOT%{_sysconfdir}/php.ini
install -m 755 -d $RPM_BUILD_ROOT%{contentdir}/icons
install -m 644    *.gif $RPM_BUILD_ROOT%{contentdir}/icons/

# For third-party packaging:
install -m 755 -d $RPM_BUILD_ROOT%{_libdir}/php/pear \
                  $RPM_BUILD_ROOT%{_datadir}/php

# install the DSO
install -m 755 -d $RPM_BUILD_ROOT%{_libdir}/httpd/modules
install -m 755 build-apache/libs/libphp5.so $RPM_BUILD_ROOT%{_libdir}/httpd/modules

# Apache config fragment
install -m 755 -d $RPM_BUILD_ROOT/etc/httpd/conf.d
install -m 644 %{SOURCE1} $RPM_BUILD_ROOT/etc/httpd/conf.d

install -m 755 -d $RPM_BUILD_ROOT%{_sysconfdir}/php.d
#install -m 755 -d $RPM_BUILD_ROOT%{_sysconfdir}/php-zts.d
install -m 755 -d $RPM_BUILD_ROOT%{_localstatedir}/lib/php
install -m 700 -d $RPM_BUILD_ROOT%{_localstatedir}/lib/php/session

# Fix the link
(cd $RPM_BUILD_ROOT%{_bindir}; ln -sfn phar.phar phar)

# Generate files lists and stub .ini files for each subpackage
for mod in mysql mysqli odbc ldap snmp xmlrpc \
    mbstring gd dom xsl soap bcmath dba xmlreader xmlwriter \
    pdo pdo_mysql pdo_odbc pdo_sqlite zip json \
    sqlite3 enchant phar fileinfo intl \
    tidy curl wddx \
    posix sysvshm sysvsem sysvmsg recode ; do
    cat > $RPM_BUILD_ROOT%{_sysconfdir}/php.d/${mod}.ini <<EOF
; Enable ${mod} extension module
extension=${mod}.so
EOF
    cat > files.${mod} <<EOF
%attr(755,root,root) %{_libdir}/php/modules/${mod}.so
%config(noreplace) %attr(644,root,root) %{_sysconfdir}/php.d/${mod}.ini
EOF
done

# Remove unpackaged files
rm -rf $RPM_BUILD_ROOT%{_libdir}/php/modules/*.a \
       $RPM_BUILD_ROOT%{_bindir}/{phptar} \
       $RPM_BUILD_ROOT%{_datadir}/pear \
       $RPM_BUILD_ROOT%{_libdir}/libphp5.la

# Remove irrelevant docs
rm -f README.{Zeus,QNX,CVS-RULES}

mv -f $RPM_BUILD_ROOT%{_libdir}/build $RPM_BUILD_ROOT%{_libdir}/php/

%files
%defattr(-,root,root)
%{_libdir}/httpd/modules/libphp5.so
%attr(0770,root,apache) %dir %{_localstatedir}/lib/php/session
%config(noreplace) %{_sysconfdir}/httpd/conf.d/php.conf
%{contentdir}/icons/php.gif

%files common
%defattr(-,root,root)
%doc CODING_STANDARDS CREDITS EXTENSIONS INSTALL LICENSE NEWS README*
%doc Zend/ZEND_*
%doc php.ini-*
%config(noreplace) %{_sysconfdir}/php.ini
%dir %{_sysconfdir}/php.d
%dir %{_libdir}/php
%dir %{_libdir}/php/modules
%dir %{_localstatedir}/lib/php
%dir %{_libdir}/php/pear
%dir %{_datadir}/php
#for now all modules are in commin, perhaps we want them separated later
%attr(755,root,root) %{_libdir}/php/modules/*.so
%config(noreplace) %attr(644,root,root) %{_sysconfdir}/php.d/*.ini

%files devel
%defattr(-,root,root)
%{_bindir}/php-config
%{_bindir}/phpize
%{_includedir}/php
%{_libdir}/php/build
%{_mandir}/man1/php-config.1*
%{_mandir}/man1/phpize.1*

%files cli
%defattr(-,root,root)
%{_bindir}/php
%{_bindir}/php-cgi
%{_bindir}/phar.phar
%{_bindir}/phar
%{_mandir}/man1/php.1*
%doc sapi/cgi/README* sapi/cli/README

%clean
rm -rf $RPM_BUILD_ROOT

%changelog
* Mon Jun 28 2010 Karsten Brockmann <arcam@ccux-linux.de> 5.3.2-3
- rebuilt against mysql 5.1.47
* Sat May 29 2010 Christian Metzen <metzench@ccux-linux.de> 5.3.2-2
- rebuild package to be upstream with package layout again
* Mon May 17 2010 Karsten Brockmann <arcam@ccux-linux.de> 5.3.2-1
- Version update
* Wed Dec 09 2009 Christian Metzen <metzench@ccux-linux.de> 5.3.1-2
- fix require for common package
* Wed Dec 09 2009 Christian Metzen <metzench@ccux-linux.de> 5.3.1-1
- Version update
- shared build, perhaps we want to seperate plugins later sometime
- own cli and http package, if only cli or devel is needed
- add http config, makes not working scriplets unnecessary
* Sat Sep 19 2008 Karsten Brockmann <arcam@ccux-linux.de> 5.2.11-1
- Version update
- suhosin 0.9.7
* Mon May 05 2008 Karsten Brockmann <arcam@ccux-linux.de> 5.2.6-1
- Version update
* Wed Feb 20 2008 Karsten Brockmann <arcam@ccux-linux.de> 5.2.5-2
- adapted apache requirement to httpd scheme
* Fri Nov 30 2007 Karsten Brockmann <arcam@ccux-linux.de> 5.2.5-1
- Version update
* Tue Nov 27 2007 Christian Metzen <metzench@ccux-linux.de> 5.2.4-3
- rebuild against net-snmp 5.4.1
* Wed Oct 31 2007 Christian Metzen <metzench@ccux-linux.de> 5.2.4-2
- rebuild against curl 7.17.7
* Mon Oct 08 2007 Karsten Brockmann <arcam@ccux-linux.de> 5.2.4-1
- Initial release
- forked from php4 package
